####################################################################################
#
#		:::[  T h e   R u s s i a n   E g g d r o p  R e s o u r c e  ]::: 
#      ____                __                                                      
#     / __/___ _ ___ _ ___/ /____ ___   ___      ___   ____ ___ _     ____ __ __   
#    / _/ / _ `// _ `// _  // __// _ \ / _ \    / _ \ / __// _ `/    / __// // /   
#   /___/ \_, / \_, / \_,_//_/   \___// .__/ __ \___//_/   \_, / __ /_/   \___/    
#        /___/ /___/                 /_/    /_/           /___/ /_/                
#
# 
#####################################################################################
#
#kurs.tcl 1.1
#
# Installation:
#	1. Make sure you correctly installed egglib_pub.
#	2. Copy kurs.tcl to scripts/ directory.
#	3. !!! AFTER !!! 'source scripts/egglib_pub.tcl' line in your eggdrop.conf add next:
#		source scripts/kurs.tcl
#	4. .rehash the bot
#
# Channel flags:
#	.chanset #chan -nopubkurs 	- enable usage of !kurs for #chan
#	.chanset #chan +nopubkurs	- disable usage of !kurs for #chan
#
# Authors: sunbeam <sunbeampro@mail.ru>
# Version History:
#	
#	
#		Who		DATE	Changes
#   	---     ------  -------------------------------------------------------------
# v1.0
#       sunbeam   050122  First initial version
#
# v1.1	sunbeam		050518	Now script uses  ::egglib::http_get to grab page
#                         Fixed some bugs  
#####################################################################################
setudef flag nopubkurs

if { ![info exists egglib(ver)] } {
	putlog "***********************************************"
	putlog "             egglib_pub NOT FOUND !"
	putlog "   Download last version of egglib_pub here:"
	putlog "  http://eggdrop.org.ru/scripts/egglib_pub.zip"
	putlog "***********************************************"	
	return
}

if { [expr {$egglib(ver) < 1.4}] } {
	putlog "***********************************************"
	putlog " YOUR VERSION OF egglib_pub IS TOO OLD !"
	putlog "   Download last version of egglib_pub here:"
	putlog "  http://eggdrop.org.ru/scripts/egglib_pub.zip"
	putlog "***********************************************"
	putlog " version installed : $egglib(ver)"
	putlog " version required: 1.4"
	return
}

foreach p [array names kurs *] { catch {unset kurs($p) } }
namespace eval kurs {}

set kurs(ver) 1.1
set kurs(authors) "sunbeam <sunbeampro@mail.ru>"

set kurs(timeout) 		20
set kurs(use_proxy) 	0
set kurs(proxy_host) 	"proxy1.bezeqint.net"
set kurs(proxy_port)	3128

bind pub - ! 		::kurs::pub_kurs
bind msg - ! 		::kurs::msg_kurs
bind pub - !kurs 		::kurs::pub_kurs
bind msg - !kurs 		::kurs::msg_kurs
bind pub - !rate 		::kurs::pub_kurs
bind msg - !rate 		::kurs::msg_kurs


proc ::kurs::msg_kurs {nick uhost hand args} {
	if { [llength [split [lindex $args 0] ] ] > 1 || [llength [split [lindex $args 0] ] ] == 0 } { set args [split [lindex $args 0]] }
	::kurs::kurs_get $nick $uhost $hand $nick $args 0
}

proc ::kurs::pub_kurs {nick uhost hand chan args} {
	if {[channel get $chan nopubkurs]} return
	if { [llength [split [lindex $args 0] ] ] > 1 || [llength [split [lindex $args 0] ] ] == 0 } { set args [split [lindex $args 0]] }
	::kurs::kurs_get $nick $uhost $hand $chan $args 0
}

proc ::kurs::kurs_get {nick uhost hand chan args} {
	global kurs
	global kurs_ar
if { [llength [split [lindex $args 0] ] ] > 1 || [llength [split [lindex $args 0] ] ] == 0 } { set args [split [lindex $args 0]] }
	if {[llength $args] < 1} { 
	   set kurs_ar ""
	} else {
	   set kurs_ar  [string toupper [string trim [lindex $args 0]]]
	}
	
	::egglib::log $chan $nick "kurs" "q='$args'"
	
	regsub -all -nocase -- "RUR" $kurs_ar "RUB" kurs_ar
	
	set query "http://www.podrobnosti.ua/finance/index.html"
	
	if {[info exists kurs(host,$uhost)]} { puthelp "NOTICE $nick :    ..."; return }
 	set kurs(host,$uhost) 1
	set id [::egglib::http_init "::kurs::"]
	if { $kurs(use_proxy) } {
		::egglib::http_set_proxy $id $kurs(proxy_host) $kurs(proxy_port)
	}
	::egglib::http_set_timeout $id $kurs(timeout)
  ::egglib::http_get $id $query [list $nick $chan $uhost]
}

proc ::kurs::on_data {id html nick chan uhost} {    
  global kurs
  global kurs_ar
    
  catch {unset kurs(host,$uhost)}
  
  regsub -all -- " " $html "" html
	regsub -all -- "\t" $html "" html
	regsub -all -- \n $html {} html
  regsub -all -nocase -- </tr> $html </tr>\n html
	
	set names ""; set add "";set name "";set kurstime ""
	
  foreach line [split $html \n] {
     set name ""
     if { [regexp -nocase -- {</b></td><tdalign=right><b>(.*?)</b></td>} $line garb kurstime] } {
           }
         
     if { [regexp -nocase -- {<tdwidth=20\%><b>(.*?)</b></td><tdwidth=30\%>(.*?)</td><tdalign=rightwidth=25\%><b>(.*?)</b></td><tdalign=rightwidth=25\%><fontcolor=\#009900>(.*?)</td></tr>} $line garb name temp kurspr diff] } {
           if { $kurs_ar == "" } {
	         	  append names "$add$name"
		          set add "\003|\0035"
	         } else {
		          if { [string equal $kurs_ar $name] } { break }	
	         }           
     } 
  }

  if { $kurs_ar == "" } {
	   ::egglib::outh $nick $chan "!" "<[string tolower $names]>"
	   return	
  }
	
  if { [string match $kurs_ar $name] } {
     regsub -all -nocase -- "RUB" $name " " name
     regsub -all -nocase -- "HKD" $name " " name
     regsub -all -nocase -- "XOF" $name "  " name
     regsub -all -nocase -- "tjs" $name " " name
     regsub -all -nocase -- "iqd" $name " " name
     regsub -all -nocase -- "sit" $name " " name
     regsub -all -nocase -- "kwd" $name " " name
     regsub -all -nocase -- "inr" $name " " name
     regsub -all -nocase -- "pen" $name "  " name
     regsub -all -nocase -- "nzd" $name " " name
     regsub -all -nocase -- "rol" $name " " name
     regsub -all -nocase -- "brl" $name " " name
     regsub -all -nocase -- "hrk" $name " " name
     regsub -all -nocase -- "krw" $name "- " name
     regsub -all -nocase -- "ils" $name " " name
     regsub -all -nocase -- "kgs" $name " " name
     regsub -all -nocase -- "syp" $name " " name
     regsub -all -nocase -- "clp" $name " " name
     regsub -all -nocase -- "mxn" $name "  " name
     regsub -all -nocase -- "bgl" $name " " name
     regsub -all -nocase -- "mtl" $name " " name
     regsub -all -nocase -- "cyp" $name " " name
     regsub -all -nocase -- "pkr" $name " " name
     regsub -all -nocase -- "sar" $name " " name
     regsub -all -nocase -- "twd" $name " " name
     regsub -all -nocase -- "gel" $name " " name
     regsub -all -nocase -- "lyd" $name " " name
     regsub -all -nocase -- "lbp" $name " " name
     regsub -all -nocase -- "egp" $name " " name
     regsub -all -nocase -- "vnd" $name " " name
     regsub -all -nocase -- "amd" $name " " name
     regsub -all -nocase -- "mnt" $name " " name
     regsub -all -nocase -- "irr" $name " " name
     regsub -all -nocase -- "kzt" $name " " name
     regsub -all -nocase -- "jpy" $name " " name
     regsub -all -nocase -- "eek" $name " " name
     regsub -all -nocase -- "eur" $name "" name
     regsub -all -nocase -- "czk" $name " " name
     regsub -all -nocase -- "cad" $name " " name
     regsub -all -nocase -- "skk" $name " " name
     regsub -all -nocase -- "sgd" $name " " name
     regsub -all -nocase -- "isk" $name " " name
     regsub -all -nocase -- "dkk" $name " " name
     regsub -all -nocase -- "try" $name "  " name
     regsub -all -nocase -- "lvl" $name " " name
     regsub -all -nocase -- "ltl" $name " " name
     regsub -all -nocase -- "uzs" $name " " name
     regsub -all -nocase -- "tmm" $name " " name
     regsub -all -nocase -- "xdr" $name "(  )" name
     regsub -all -nocase -- "sek" $name " " name
     regsub -all -nocase -- "pln" $name " " name
     regsub -all -nocase -- "nok" $name " " name
     regsub -all -nocase -- "huf" $name " " name
     regsub -all -nocase -- "gbp" $name "  " name
     regsub -all -nocase -- "azm" $name " " name
     regsub -all -nocase -- "mdl" $name " " name
     regsub -all -nocase -- "chf" $name " " name
     regsub -all -nocase -- "usd" $name " " name
     regsub -all -nocase -- "byr" $name " " name
     regsub -all -nocase -- "aud" $name " " name
     regsub -all -nocase -- "cny" $name " " name
		 ::egglib::out $nick $chan "\0032  \0034\0032  \00312$name \0032\0036 $kurstime \0032\0032 - \0033\002\002[format "%5.4f" $kurspr] .\003"
		 return
	} else {
		 ::egglib::out $nick $chan "\0032    $kurs_ar...\003"
		 return
	}	
}  
  

proc ::kurs::on_error {id nick chan uhost} {
   ::egglib::outc $nick $chan "    ... -.-"
}

putlog "kurs.tcl v$kurs(ver) by $kurs(authors) loaded"